package com.example;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;

import java.io.IOException;

public class CartController {

    @FXML
    private Button cartBtn;

    @FXML
    private Button loginBtn;

    @FXML
    private Button btnCheckOut;

    @FXML
    private TableView<Item> cartContent;

    @FXML
    private TableColumn<Item, String> nameColumn;

    @FXML
    private TableColumn<Item, String> descriptionColumn;

    @FXML
    private TableColumn<Item, Integer> quantityColumn;

    @FXML
    private TableColumn<Item, Double> priceColumn;

    @FXML
    private Label cartTitle;

    @FXML
    private Label mainTitle;

    // Observable list to hold cart items
    private final ObservableList<Item> cartItems = FXCollections.observableArrayList();

    // Initialize method to set up the TableView
    @FXML
    public void initialize() {
        // Set up columns to match Item properties
        nameColumn.setCellValueFactory(new PropertyValueFactory<>("name"));
        descriptionColumn.setCellValueFactory(new PropertyValueFactory<>("description"));
        quantityColumn.setCellValueFactory(new PropertyValueFactory<>("quantity"));
        priceColumn.setCellValueFactory(new PropertyValueFactory<>("price"));

        // Populate the cart table with sample data for demonstration
        cartItems.addAll(
                new Item("Book A", "A fascinating fantasy novel.", 1, 12.99),
                new Item("Book B", "A thrilling sequel.", 2, 10.50));
        cartContent.setItems(cartItems);
    }

    @FXML
    private void handleCartButton(ActionEvent event) {
        System.out.println("Cart button clicked!");
        try {
            App.setRoot("cart");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @FXML
    private void handleLoginButton(ActionEvent event) {
        System.out.println("Login button clicked!");
        try {
            App.setRoot("login");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @FXML
    private void handleCheckOutButton(ActionEvent event) {
        if (cartItems.isEmpty()) {
            System.out.println("Cart is empty. Cannot proceed to checkout.");
            return;
        }

        System.out.println("Proceeding to checkout...");
        try {
            App.setRoot("checkout");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
